#ifndef DOC_H_
#define DOC_H_

#include <stdio.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_rng.h>

struct strct_doc {

	int word_count; // total # of words
	int item_count; // total # of distinct words
	double y;
	int *index, *count;

	double yhat;
	gsl_vector *h; //the topic mixing vector
	int *z; //1..K, of length [word_count]

};

strct_doc* read_docs(FILE *f, int* ndocs, int* V);
void write_docs(strct_doc* docs, int ndocs, FILE* f);
void init_hz(strct_doc* doc, int K, gsl_rng* rng);
//void swap_docs(strct_doc*, strct_doc*);

// Note: the h field must be filled
double* ols_predict_y_using_h(strct_doc* train_docs, int train_ndocs, strct_doc* test_docs, int test_ndocs, int K);

// Note: the z field must be filled
double* ols_predict_y_using_z(strct_doc* train_docs, int train_ndocs, strct_doc* test_docs, int test_ndocs, int K);

#endif
